'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FormProvider = exports.FormEventDispatcher = exports.REACT_FORMCTRL = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var REACT_FORMCTRL_NAME = 'react-formctl';

var INTEGER_REGEX = /^-?\d+?$/;
var FLOAT_REGEX = /^-?\d+(\.\d+)?$/;
var EMAIL_REGEX = /\S+@\S+\.\S+/;

var PROVIDER_FLAG = REACT_FORMCTRL_NAME + '.FormProvider';

var REACT_FORMCTRL = exports.REACT_FORMCTRL = {
    EVENTS: {
        REGISTER_FORM: REACT_FORMCTRL_NAME + '.registerForm',
        UNREGISTER_FORM: REACT_FORMCTRL_NAME + '.unregisterForm',
        REGISTER_FIELD: REACT_FORMCTRL_NAME + '.registerField',
        UNREGISTER_FIELD: REACT_FORMCTRL_NAME + '.unregisterField',
        FORM_CHANGED: REACT_FORMCTRL_NAME + '.formChanged',
        FIELD_CHANGED: REACT_FORMCTRL_NAME + '.fieldChanged',
        FIELD_PROPS_CHANGED: REACT_FORMCTRL_NAME + '.fieldPropsChanged',
        FIELD_BLURRED: REACT_FORMCTRL_NAME + '.fieldBlurred',
        FORM_SUBMITED: REACT_FORMCTRL_NAME + '.formSubmited',
        FORM_RESETED: REACT_FORMCTRL_NAME + '.formReseted'
    }
};

var FormEventDispatcher = exports.FormEventDispatcher = function () {
    function FormEventDispatcher() {
        _classCallCheck(this, FormEventDispatcher);
    }

    _createClass(FormEventDispatcher, null, [{
        key: 'copy',
        value: function copy(payload) {
            return JSON.parse(JSON.stringify(payload));
        }
    }, {
        key: 'dispatchRegisterForm',
        value: function dispatchRegisterForm(form) {
            var payload = FormEventDispatcher.copy({ detail: { form: form } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.REGISTER_FORM, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchUnregisterForm',
        value: function dispatchUnregisterForm(form) {
            var payload = FormEventDispatcher.copy({ detail: { form: form } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.UNREGISTER_FORM, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchSubmitForm',
        value: function dispatchSubmitForm(form, formRef) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, formRef: formRef } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FORM_SUBMITED, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchResetForm',
        value: function dispatchResetForm(form) {
            var payload = FormEventDispatcher.copy({ detail: { form: form } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FORM_RESETED, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchRegisterField',
        value: function dispatchRegisterField(form, field, fieldCtrl) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, field: field, fieldCtrl: fieldCtrl } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.REGISTER_FIELD, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchUnregisterField',
        value: function dispatchUnregisterField(form, field) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, field: field } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.UNREGISTER_FIELD, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchFieldPropsChanged',
        value: function dispatchFieldPropsChanged(form, field, props) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, field: field, props: props } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FIELD_PROPS_CHANGED, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchFieldChanged',
        value: function dispatchFieldChanged(form, field, value) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, field: field, value: value } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FIELD_CHANGED, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchFieldBlur',
        value: function dispatchFieldBlur(form, field) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, field: field } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FIELD_BLURRED, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'forwardSubmitFormEvent',
        value: function forwardSubmitFormEvent(form, values, formCtrl, formRef) {
            var payload = FormEventDispatcher.copy({ detail: { values: values, formCtrl: formCtrl, formRef: formRef } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FORM_SUBMITED + '#' + form, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'forwardFieldChangedEvent',
        value: function forwardFieldChangedEvent(form, field, fieldCtrl) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, field: field, fieldCtrl: fieldCtrl } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FIELD_CHANGED + '#' + form + '#' + field, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'forwardFormChangedEvent',
        value: function forwardFormChangedEvent(form, formCtrl) {
            var payload = FormEventDispatcher.copy({ detail: { form: form, formCtrl: formCtrl } });
            var event = new CustomEvent(REACT_FORMCTRL.EVENTS.FORM_CHANGED + '#' + form, payload);
            document.dispatchEvent(event);
        }
    }]);

    return FormEventDispatcher;
}();

var FormProvider = exports.FormProvider = function (_React$Component) {
    _inherits(FormProvider, _React$Component);

    function FormProvider(props) {
        _classCallCheck(this, FormProvider);

        var _this = _possibleConstructorReturn(this, (FormProvider.__proto__ || Object.getPrototypeOf(FormProvider)).call(this, props));

        _this.state = {
            forms: {}
        };
        _this.subscribe = _this.subscribe.bind(_this);
        _this.unsubscribe = _this.unsubscribe.bind(_this);
        _this.onEvent = _this.onEvent.bind(_this);
        _this.onRegisterForm = _this.onRegisterForm.bind(_this);
        _this.onUnregisterForm = _this.onUnregisterForm.bind(_this);
        _this.onRegisterField = _this.onRegisterField.bind(_this);
        _this.onUnregisterField = _this.onUnregisterField.bind(_this);
        _this.onFieldChanged = _this.onFieldChanged.bind(_this);
        _this.onFieldPropsChanged = _this.onFieldPropsChanged.bind(_this);
        _this.onFieldBlurred = _this.onFieldBlurred.bind(_this);
        _this.onFormSubmited = _this.onFormSubmited.bind(_this);
        _this.onFormReseted = _this.onFormReseted.bind(_this);
        _this.updateFormCtrl = _this.updateFormCtrl.bind(_this);
        _this.updateFieldCtrl = _this.updateFieldCtrl.bind(_this);
        return _this;
    }

    _createClass(FormProvider, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            // if (window.sessionStorage.getItem(PROVIDER_FLAG)) {
            //     throw 'Two instances of FormProvided found, only one instance can exists because events erros may occur.'
            // }
            // window.sessionStorage.setItem(PROVIDER_FLAG, 'true')
            this.subscribe();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            // window.sessionStorage.removeItem(PROVIDER_FLAG)
            this.unsubscribe();
        }
    }, {
        key: 'subscribe',
        value: function subscribe() {
            document.addEventListener(REACT_FORMCTRL.EVENTS.REGISTER_FORM, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.REGISTER_FIELD, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.UNREGISTER_FORM, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.UNREGISTER_FIELD, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.FIELD_CHANGED, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.FIELD_BLURRED, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.FIELD_PROPS_CHANGED, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.FORM_SUBMITED, this.onEvent);
            document.addEventListener(REACT_FORMCTRL.EVENTS.FORM_RESETED, this.onEvent);
        }
    }, {
        key: 'onEvent',
        value: function onEvent(event) {
            var type = event.type;
            var payload = event.detail;
            var EVENTS = REACT_FORMCTRL.EVENTS;
            switch (type) {
                case EVENTS.REGISTER_FORM:
                    this.onRegisterForm(payload.form);
                    break;
                case EVENTS.UNREGISTER_FORM:
                    this.onUnregisterForm(payload.form);
                    break;
                case EVENTS.REGISTER_FIELD:
                    this.onRegisterField(payload.form, payload.field, payload.fieldCtrl);
                    break;
                case EVENTS.UNREGISTER_FIELD:
                    this.onUnregisterField(payload.form, payload.field);
                    break;
                case EVENTS.FIELD_CHANGED:
                    this.onFieldChanged(payload.form, payload.field, payload.value);
                    break;
                case EVENTS.FIELD_PROPS_CHANGED:
                    this.onFieldPropsChanged(payload.form, payload.field, payload.props);
                    break;
                case EVENTS.FIELD_BLURRED:
                    this.onFieldBlurred(payload.form, payload.field);
                    break;
                case EVENTS.FORM_SUBMITED:
                    this.onFormSubmited(payload.form, payload.formRef);
                    break;
                case EVENTS.FORM_RESETED:
                    this.onFormReseted(payload.form);
                    break;
                default:
                    break;
            }
        }
    }, {
        key: 'onRegisterForm',
        value: function onRegisterForm(formName) {
            this.setState(function (state) {
                var forms = _extends({}, state.forms);
                if (forms[formName]) {
                    var form = forms[formName];
                    form.__instances++;
                } else {
                    forms[formName] = {
                        __instances: 1,
                        formName: formName,
                        valid: true,
                        invalid: false,
                        untouched: true,
                        touched: false,
                        pristine: true,
                        dirty: false,
                        unchanged: true,
                        changed: false,
                        fields: {},
                        values: {}
                    };
                }
                return { forms: forms };
            });
        }
    }, {
        key: 'onRegisterField',
        value: function onRegisterField(formName, fieldName, fieldCtrl) {
            var _this2 = this;

            this.setState(function (state) {
                if (state.forms[formName]) {
                    var forms = _extends({}, state.forms);
                    var form = forms[formName];
                    if (form.fields[fieldName]) {
                        fieldCtrl.__instances = form.fields[fieldName].__instances + 1;
                    } else {
                        fieldCtrl.__instances = 1;
                    }
                    _this2.updateFieldCtrl(formName, fieldCtrl, fieldCtrl.initialValue);
                    FormEventDispatcher.forwardFieldChangedEvent(formName, fieldName, fieldCtrl);

                    form.fields[fieldName] = fieldCtrl;
                    form.values[fieldName] = fieldCtrl.value;
                    _this2.updateFormCtrl(formName, form);
                    return { forms: forms };
                } else {
                    console.warn('No form instance with name "' + formName + '" to register field "' + fieldName + '".');
                }
                return state;
            });
        }
    }, {
        key: 'onUnregisterForm',
        value: function onUnregisterForm(formName) {
            this.setState(function (state) {
                if (state.forms[formName]) {
                    var forms = _extends({}, state.forms);
                    var form = forms[formName];
                    if (form.__instances > 1) {
                        form.__instances--;
                    } else {
                        delete forms[formName];
                    }
                    return { forms: forms };
                }
                return state;
            });
        }
    }, {
        key: 'onUnregisterField',
        value: function onUnregisterField(formName, fieldName) {
            this.setState(function (state) {
                if (state.forms[formName]) {
                    if (state.forms[formName].fields[fieldName]) {
                        var forms = _extends({}, state.forms);
                        var form = forms[formName];
                        var field = form.fields[fieldName];
                        if (field.__instances > 1) {
                            field.__instances--;
                        } else {
                            delete form.fields[fieldName];
                        }
                        return { forms: forms };
                    }
                }
                return state;
            });
        }
    }, {
        key: 'onFieldChanged',
        value: function onFieldChanged(formName, fieldName, value) {
            var _this3 = this;

            this.setState(function (state) {
                if (state.forms[formName]) {
                    if (state.forms[formName].fields[fieldName]) {
                        var forms = _extends({}, state.forms);
                        var form = forms[formName];
                        var fieldCtrl = form.fields[fieldName];
                        fieldCtrl.dirty = true;
                        fieldCtrl.pristine = false;
                        _this3.updateFieldCtrl(formName, fieldCtrl, value);
                        FormEventDispatcher.forwardFieldChangedEvent(formName, fieldName, fieldCtrl);
                        if (!form.values) form.values = {};
                        form.values[fieldName] = value;
                        _this3.updateFormCtrl(formName, form);
                        return { forms: forms };
                    }
                }
                return state;
            });
        }
    }, {
        key: 'onFieldPropsChanged',
        value: function onFieldPropsChanged(formName, fieldName, props) {
            var _this4 = this;

            this.setState(function (state) {
                var forms = _extends({}, state.forms);
                var form = forms[formName];
                var field = form.fields[fieldName];
                field.props = props;
                _this4.updateFieldCtrl(formName, field, field.value);
                FormEventDispatcher.forwardFieldChangedEvent(formName, fieldName, field);
                _this4.updateFormCtrl(formName, form);
                return { forms: forms };
            });
        }
    }, {
        key: 'onFieldBlurred',
        value: function onFieldBlurred(formName, fieldName) {
            var _this5 = this;

            this.setState(function (state) {
                var forms = _extends({}, state.forms);
                var form = forms[formName];
                var field = form.fields[fieldName];
                field.touched = true;
                field.untouched = false;
                FormEventDispatcher.forwardFieldChangedEvent(formName, fieldName, field);
                _this5.updateFormCtrl(formName, form);
                return { forms: forms };
            });
        }
    }, {
        key: 'updateFormCtrl',
        value: function updateFormCtrl(formName, form) {
            form.valid = true;
            form.invalid = false;
            form.untouched = true;
            form.touched = false;
            form.pristine = true;
            form.dirty = false;
            form.unchanged = true;
            form.changed = false;
            Object.keys(form.fields).forEach(function (fieldName) {
                var field = form.fields[fieldName];
                if (!field.valid) form.valid = false;
                if (field.invalid) form.invalid = true;
                if (!field.untouched) form.untouched = false;
                if (field.touched) form.touched = true;
                if (!field.pristine) form.pristine = false;
                if (field.dirty) form.dirty = true;
                if (!field.unchanged) form.unchanged = false;
                if (field.changed) form.changed = true;
            });
            FormEventDispatcher.forwardFormChangedEvent(formName, form);
        }
    }, {
        key: 'updateFieldCtrl',
        value: function updateFieldCtrl(formName, fieldCtrl, value) {
            var errors = [];
            var initialValue = fieldCtrl.initialValue,
                _fieldCtrl$props = fieldCtrl.props,
                _fieldCtrl$props$type = _fieldCtrl$props.type,
                type = _fieldCtrl$props$type === undefined ? 'text' : _fieldCtrl$props$type,
                required = _fieldCtrl$props.required,
                pattern = _fieldCtrl$props.pattern,
                match = _fieldCtrl$props.match,
                integer = _fieldCtrl$props.integer,
                min = _fieldCtrl$props.min,
                max = _fieldCtrl$props.max,
                minLength = _fieldCtrl$props.minLength,
                maxLength = _fieldCtrl$props.maxLength;


            if (required && !value) errors.push('required');else if (pattern && !new RegExp(pattern).test(value)) errors.push('pattern');else if (match) {
                var form = this.state.forms[formName];
                if (form && form.values[match] != value) errors.push('match');
            } else {
                if (type === 'email' && !EMAIL_REGEX.test(value)) errors.push('email');
                if (type === 'number') {
                    if (integer && !INTEGER_REGEX.test(value)) errors.push('integer');
                    if (!integer && !FLOAT_REGEX.test(value)) errors.push('float');
                    if (min && +value < min) errors.push('min');
                    if (max && +value > max) errors.push('max');
                } else {
                    if (minLength && value && value.length < minLength) errors.push('minLength');
                    if (maxLength && value && value.length > maxLength) errors.push('maxLength');
                }
            }

            fieldCtrl.value = value;
            fieldCtrl.errors = errors;
            fieldCtrl.unchanged = value === initialValue;
            fieldCtrl.changed = value !== initialValue;
            fieldCtrl.valid = errors.length === 0;
            fieldCtrl.invalid = errors.length > 0;
        }
    }, {
        key: 'onFormSubmited',
        value: function onFormSubmited(formName, formRef) {
            this.setState(function (state) {
                var form = state.forms[formName];
                if (form) {
                    FormEventDispatcher.forwardSubmitFormEvent(formName, form.values, form, formRef);
                }
                return state;
            });
        }
    }, {
        key: 'onFormReseted',
        value: function onFormReseted(formName) {
            var _this6 = this;

            this.setState(function (state) {
                var forms = _extends({}, state.forms);
                var form = forms[formName];
                Object.keys(form.fields).forEach(function (fieldName) {
                    var field = form.fields[fieldName];
                    _this6.updateFieldCtrl(formName, field, field.initialValue);
                    field.touched = false;
                    field.untouched = true;
                    field.dirty = false;
                    field.pristine = true;
                    FormEventDispatcher.forwardFieldChangedEvent(formName, fieldName, field);
                    form.values[fieldName] = field.initialValue;
                });
                _this6.updateFormCtrl(formName, form);
                return state;
            });
        }
    }, {
        key: 'unsubscribe',
        value: function unsubscribe() {
            document.removeEventListener(REACT_FORMCTRL.EVENTS.REGISTER_FORM, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.REGISTER_FIELD, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.UNREGISTER_FORM, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.UNREGISTER_FIELD, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.FIELD_CHANGED, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.FIELD_BLURRED, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.FIELD_PROPS_CHANGED, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.FORM_SUBMITED, this.onEvent);
            document.removeEventListener(REACT_FORMCTRL.EVENTS.FORM_RESETED, this.onEvent);
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;

            return children;
        }
    }]);

    return FormProvider;
}(_react2.default.Component);

FormProvider.propTypes = {};